import os

from flask import Blueprint, jsonify, request

from db import db
from helper_functions import check_password, hash_password
from models import User

api = Blueprint('api', __name__, url_prefix='/api')
__location__ = os.path.realpath(os.path.join(os.getcwd(), os.path.dirname(__file__)))


@api.route('/users', methods=['GET'])
def users():
    res = []
    for i in User.query.all():
        res.append(i.as_dict())

    return jsonify(res)


@api.route('/login', methods=['POST'])
def login():
    request_data = request.get_json()
    username = request_data['username']
    password = request_data['password']

    user = User.filter_by(username=username).first()
    if check_password(user.password, password):
        return True  # TODO Return token
    else:
        return False


@api.route('/logout', methods=['GET'])
def logout():
    # TODO
    pass


@api.route('/register', methods=['POST'])
def register():
    request_data = request.get_json()
    username = request_data['username']
    password = request_data['password']

    user = User(
        username=username,
        password=hash_password(password),
        admin=False
    )
    db.session.add(user)
    db.session.commit()

    pass
